﻿Public Class DialogFenster
    Private windowname As String
    Private widthAndHeight As SizeToContent
    Private centerOwner As WindowStartupLocation

    Public Sub New(windowname As String, datacontext As Object, widthAndHeight As SizeToContent, centerOwner As WindowStartupLocation)
        Me.windowname = windowname
        Me.DataContext = datacontext
        Me.widthAndHeight = widthAndHeight
        Me.centerOwner = centerOwner
    End Sub

    Public Shared Function FindOwnerWindow(viewModel As Object) As Window
        ' if the ViewModel of the caller is set, we try to find the corresponding Window
        If viewModel IsNot Nothing Then
            If viewModel.GetType Is GetType(DialogFenster) Then Return CType(viewModel, Window)
            If Application.Current.Windows.Cast(Of Window)().SingleOrDefault(Function(x) x.DataContext IsNot Nothing AndAlso x.DataContext.GetType Is viewModel.GetType) Is Nothing Then
                For Each window As Window In (From win In Application.Current.Windows()).ToList
                    If window.DataContext IsNot Nothing AndAlso window.DataContext.GetType Is viewModel.GetType Then
                        Return window
                    End If
                Next
            Else
                Return Application.Current.Windows.Cast(Of Window)().SingleOrDefault(Function(x) x.DataContext IsNot Nothing AndAlso x.DataContext.GetType Is viewModel.GetType)
            End If
        End If
        ' by default we use the active Window in the List as owner
        Return Application.Current.Windows.Cast(Of Window)().SingleOrDefault(Function(x) x.IsActive)
    End Function
End Class
